/* mymint.h                     freeware                   xhunga@tiscali.fr  */


/* ------------------------------ FUNCTION ------------------------- fminiF() */
/* Do    : fminiF[(a*c)/(b*c)] = (a)/(b)                                      */
/*        if numerator = 0, the fraction is write 0 = 0/1                     */
/* Call  : fmod()                                                             */
/* Debug : printmF(m); getchar();                                             */
/*         printf(" %.1f / %d \n\n",t,tnb1er[nb1er]);   getchar();            */
/* -------------------------------------------------------------------------- */
fraction fminiF(
fraction f)
{
     int  nb1er = FIRSTNB1ER;
     int ttrue  = 1;

while(nb1er < LASTNB1ER)
 {
  ttrue  = 1;
  while(ttrue)                             /* ttrue = 1 try tnb1er[nb1er    ] */
  {                                        /* ttrue = 0 try tnb1er[nb1er + 1] */
   if( fmod(f.numer,tnb1er[nb1er]) != 0 || fmod(f.denom,tnb1er[nb1er]) != 0)
       {
          ttrue = 0;
       }

   if(  tnb1er[nb1er] > fabs(f.numer) || tnb1er[nb1er] > fabs(f.denom) )
      {
       nb1er = LASTNB1ER;
       ttrue = 0;
      }
                                         /* ttrue = 1 divide by tnb1er[nb1er] */
    if(ttrue)
       {
          f.numer = f.numer / tnb1er[nb1er];
          f.denom = f.denom / tnb1er[nb1er];
       }
  }
  nb1er++;
 }

if(f.denom < 0 )                      /* Only the numerator is signed */
{
 f.numer = -1 * (f.numer);
 f.denom = -1 * (f.denom);
}

return(f);
}


/* ------------------------------ FUNCTION ---------------------- frowminiF() */
/* Do   : apply fminiF() on a row                                             */
/* Call : fminiF()                                                            */
/* Debug : printmF(m); getchar();                                             */
/*         printf(" %.1f / %d \n\n",t,tnb1er[nb1er]);   getchar();            */
/* -------------------------------------------------------------------------- */
void frowminiF(
pmatrix m,
int     row)
{
  int    j;
double   t;
fraction f;

 for ( j = 0 ; j < m->cols ; j++,j++ )
    {
     f.numer = *(m->pblock + row *m->cols + j    );
     f.denom = *(m->pblock + row *m->cols + j + 1);

     f = fminiF(f);

     *(m->pblock + row *m->cols + j    ) = f.numer;
     *(m->pblock + row *m->cols + j + 1) = f.denom;

/* ------------- if numerator = 0, denominator = 1. This is my choise 0 = 0/1 */
                t = *(m->pblock + row *m->cols + j    );
            if(!t){ *(m->pblock + row *m->cols + j + 1) = 1; }
    }
}

/* ------------------------------ FUNCTION ----------------------- rowminiF() */
/* Do    :                                                                    */
/* Call  : fmod()                                                             */
/* Debug : printmF(m); getchar();                                             */
/*         printf(" %.1f / %d \n\n",t,tnb1er[nb1er]);   getchar();            */
/* -------------------------------------------------------------------------- */
fraction rowminiF(
pmatrix m,
    int row)
{
     int j;
     int i;
  double t;
     int nb1er   = FIRSTNB1ER;
     int ttrue   = 1;
fraction f;
         f.numer = 1;
         f.denom = 1;

/* ************************************************************************** */
/* In this function 0 = 0/0. In other part 0 = 0/1.                           */
/* Why :  rowminiF(1, 2, 4, 6, 8) = 1, 2, 4, 6, 8                             */
/*        rowminiF(0, 2, 4, 6, 8) = 0, 1, 2, 3, 4                             */
/*        0 is a multiple of any numbers                                      */
/*        1 is a multiple of 1                                                */
/* ************************************************************************** */
for (j = 0;  j < m->cols ; j++, j++)
{
 t = *(m->pblock + row *m->cols + j);
 if(!t)
 {
 *(m->pblock + row *m->cols + j + 1 ) = 0;
 }
}
/* ************************************************************************** */

for(i = 0; i < 2 ; i++)         /* i = 0 -> numerators, i = 1 -> denominators */
{
nb1er = FIRSTNB1ER;
while(nb1er < LASTNB1ER)
 {
  ttrue  = 1;                             /* ttrue = 1 try tnb1er[nb1er     ] */
       j = i ;                            /*    the first column of the row n */

/* ========================================================================== */
     while((j < m->cols) && (ttrue))      /*     all the columns of the row n */
      {
      t = *(m->pblock + row *m->cols + j);
/* -------------------------------- true = 0 ? ------------------------------ */
      if( (fmod(t,tnb1er[nb1er]) != 0) )
         {
           ttrue = 0; /* a value of the row n is not multiple of tnb1er[nb1er]*/
           j = m->cols;
         }


      if( (tnb1er[nb1er]) > fabs(t))
        {
          nb1er = LASTNB1ER-1;
          ttrue = 0; /* a value of the row n is not multiple of tnb1er[nb1er] */
              j = m->cols;
        }
/* -------------------------------- true = 0 ? ------------------------------ */
       j++; j++;
      }
/* ========================================================================== */


/* ########################################################################## */
/* -------------------------------- true = 1 -------------------------------- */
     if(ttrue)
       {
/*                            save tnb1er[nb1er] to calculate the determinant */
        if( i){f.denom *= tnb1er[nb1er];}
        if(!i){f.numer *= tnb1er[nb1er];}
               f        = fminiF(f);
/*                                            divide the row by tnb1er[nb1er] */
        for (j = i;  j < m->cols ; j++, j++)
         {
          *(m->pblock + row *m->cols + j) = \
          *(m->pblock + row *m->cols + j) / tnb1er[nb1er];

         }
       }
/* -------------------------------- true = 1 -------------------------------- */
/* ########################################################################## */

  nb1er++;
 }
}

/* ************************************************************************** */
/* In this function   0 = 0/0.                                                */
/* In other part      0 = 0/1.                                                */
/* Now you must write 0 = 0/1.                                                */
/* ************************************************************************** */
for (j = 0;  j < m->cols ; j++, j++)
{
 t = *(m->pblock + row *m->cols + j);
 if(!t)
 {
 *(m->pblock + row *m->cols + j + 1 ) = 1;
 }
}
/* ************************************************************************** */

return(f);
}


